<template>
  <div
    :class="{ '-inited': isInit }"
    class="appAbstractMap">
    <div class="mapLoader">
      <div class="action"/>
    </div>
    <YandexMap
      :zoom="zoom"
      :key="KEY"
      :coords="coords"
      :controls="$options.YandexMapControls"
      :use-object-manager="true"
      :object-manager-clusterize="true"
      :cluster-options="$options.YandexMapClusterOptions"
      :init-without-markers="false"
      @map-was-initialized="getMapInstance">
      <template v-for="placemark in placemarks">
        <YandexMapMarker
          :key="generateKey(placemark) || '1'"
          :coords="getCoords(placemark)"
          :options="getMarkerStyle(placemark.type)"
          :marker-id="generateKey(placemark) || '1'"
          :hint-content="renderHintComponent(placemark)"
          :properties="{
            type: placemark.type || null
          }"
          cluster-name="0"
          marker-type="placemark"
        />
      </template>
    </YandexMap>
    <slot
      v-if="placemarks.length"
      name="balloon"
      :marker-id="generateKey(placemarks[activeEntityIndex])"
      :balloon-entity="placemarks[activeEntityIndex]"
      :balloon-position="balloonPositionMap"
      :balloon-direction="balloonDirection"
      :balloon-configuration="balloonConfiguration"
      :balloon-opened="balloonOpened"
      :close-balloon="closeBalloon"
    />
    <slot
      name="filter"
    />
  </div>
</template>

<script>
import Vue from 'vue';
import {
  isNil,
  isEmpty,
} from 'lodash-es';
import { yandexMap, ymapMarker } from 'vue-yandex-maps';
import createHintEntity from '~/assets/js/helpers/hint/createHintEntity';
import generateMapMarkerKey from '~/assets/js/helpers/generate-map-marker-key';

const mapMarkerSvgOriginals = "data:image/svg+xml,%3Csvg width='22' height='33' viewBox='0 0 22 33' fill='none' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath d='M16.6568 5.39236C13.5329 2.20254 8.46756 2.20254 5.34315 5.39236C2.52815 8.26671 2.21127 13.6788 4.60023 16.9311L11 27L17.3998 16.9311C19.7887 13.6788 19.4718 8.26671 16.6568 5.39236ZM11.0779 13.7853C9.61935 13.7853 8.43719 12.5782 8.43719 11.0889C8.43719 9.59962 9.61935 8.39254 11.0779 8.39254C12.5365 8.39254 13.7186 9.59962 13.7186 11.0889C13.7186 12.5782 12.5365 13.7853 11.0779 13.7853Z' fill='%2314A41A'/%3E%3Cpath d='M4.27156 4.34275L4.27149 4.34283C2.56189 6.08846 1.67316 8.52682 1.52313 10.9264C1.37416 13.3091 1.94254 15.8214 3.36011 17.7763L9.73407 27.8046L11 29.7963L12.2659 27.8046L18.6399 17.7763C20.0575 15.8214 20.6258 13.3091 20.4769 10.9264C20.3268 8.52682 19.4381 6.08846 17.7285 4.34283L16.6568 5.39236L17.7285 4.34283C14.0163 0.552349 7.98412 0.552459 4.27156 4.34275ZM11.0779 12.2853C10.4771 12.2853 9.93719 11.7795 9.93719 11.0889C9.93719 10.3984 10.4771 9.89254 11.0779 9.89254C11.6787 9.89254 12.2186 10.3984 12.2186 11.0889C12.2186 11.7795 11.6787 12.2853 11.0779 12.2853Z' stroke='white' stroke-opacity='0.8' stroke-width='3'/%3E%3C/svg%3E%0A";
const mapMarkerSvgAnalogs = "data:image/svg+xml,%3Csvg width='22' height='33' viewBox='0 0 22 33' fill='none' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath d='M16.6568 5.39236C13.5329 2.20254 8.46756 2.20254 5.34315 5.39236C2.52815 8.26671 2.21127 13.6788 4.60023 16.9311L11 27L17.3998 16.9311C19.7887 13.6788 19.4718 8.26671 16.6568 5.39236ZM11.0779 13.7853C9.61935 13.7853 8.43719 12.5782 8.43719 11.0889C8.43719 9.59962 9.61935 8.39254 11.0779 8.39254C12.5365 8.39254 13.7186 9.59962 13.7186 11.0889C13.7186 12.5782 12.5365 13.7853 11.0779 13.7853Z' fill='%23F75A52'/%3E%3Cpath d='M4.27156 4.34275L4.27149 4.34283C2.56189 6.08846 1.67316 8.52682 1.52313 10.9264C1.37416 13.3091 1.94254 15.8214 3.36011 17.7763L9.73407 27.8046L11 29.7963L12.2659 27.8046L18.6399 17.7763C20.0575 15.8214 20.6258 13.3091 20.4769 10.9264C20.3268 8.52682 19.4381 6.08846 17.7285 4.34283L16.6568 5.39236L17.7285 4.34283C14.0163 0.552349 7.98412 0.552459 4.27156 4.34275ZM11.0779 12.2853C10.4771 12.2853 9.93719 11.7795 9.93719 11.0889C9.93719 10.3984 10.4771 9.89254 11.0779 9.89254C11.6787 9.89254 12.2186 10.3984 12.2186 11.0889C12.2186 11.7795 11.6787 12.2853 11.0779 12.2853Z' stroke='white' stroke-opacity='0.8' stroke-width='3'/%3E%3C/svg%3E%0A";

export default {
  name: 'AppAbstractMap',
  components: {
    YandexMap: yandexMap,
    YandexMapMarker: ymapMarker,
  },
  props: {
    placemarks: {
      type: Array,
      default() { return []; },
    },
    activeEntityIndex: {
      type: Number,
      default: 0,
    },
    filters: {
      type: Array,
      default() { return []; },
    },
    canShowMobile: {
      type: Boolean,
      default: false,
    },
    balloonConfiguration: {
      type: Object,
      default() { return {}; },
    },
    hintConfiguration: {
      type: Object,
      default() { return {}; },
    },
    bus: {
      type: Object,
      default() { return null; },
    },
    zoom: {
      type: Number,
      default() { return 9; },
    },
    initCoords: {
      type: Object,
      default() { return null; },
    },
  },
  data() {
    return {
      currentMap: null,
      isInit: false,
      coords: [0, 0],
      KEY: 1,
      mapReady: false,
      balloonOpened: false,
      balloonPositionMap: [0, 0],
      balloonDirection: 'default',
      activeMarkerId: null,
    };
  },
  watch: {
    placemarks: {
      handler() {
        this.KEY += 1;
      },
      deep: true,
    },
    activeEntityIndex() {
      // this.onChangeActiveEntityIndex();
    },
  },
  created() {
    this.$options.YandexMapClusterOptions = {
      0: {
        clusterIconLayout: 'default#pieChart',
        clusterDisableClickZoom: false,
        clusterOpenBalloonOnClick: false,
        minClusterSize: 3,
      },
    };
    // Массив подключенных поведений карты.
    this.$options.YandexMapControls = [
      'zoomControl',
      'fullscreenControl',
      'geolocationControl',
    ];
    // Опции для иконки самого маркера
    this.$options.getYandexMapMarkerIconSetting = {
      hideIconOnBalloonOpen: false,
      iconLayout: 'default#image',
      iconImageSize: [28, 40],
      iconImageOffset: [0, 0],
      iconShadow: true,
      zIndex: 110,
    };
    this.$options.YandexMapMarkerTypeA = {
      ...this.$options.getYandexMapMarkerIconSetting,
      iconImageHref: mapMarkerSvgOriginals,
      iconColor: '#14A41A',
    };
    this.$options.YandexMapMarkerTypeB = {
      ...this.$options.getYandexMapMarkerIconSetting,
      iconImageHref: mapMarkerSvgAnalogs,
      iconColor: '#F75A52',
    };
    this.$options.YandexMapMarkerDefault = {
      preset: 'islands#icon',
      hideIconOnBalloonOpen: false,
      iconColor: '#ed4543',
      zIndex: 110,
    };
  },
  mounted() {
    if (!isNil(this.bus)) {
      this.bus.$on('toggle-filter', (filters) => {
        this.closeBalloon();
        this.currentMap.setCenter(
          this.getCoords(
            this.placemarks[this.activeEntityIndex]
          ), this.zoom
        );
        this.applyMarkerFilters(filters);
      });
    }
  },
  destroyed() {
    if (!isNil(this.bus)) {
      this.bus.$off('toggle-filter');
    }
  },
  methods: {
    async getMapInstance(map) {
      if (!isNil(map)) {
        try {
          this.currentMap = map;
          // @TODO Сделать без setTimeout когда появится синхронный coords
          // https://github.com/PNKBizz/vue-yandex-map/issues/148

          this.currentMap.options.set('placemark');
          this.currentMap.options.set('yandexMapDisablePoiInteractivity', true);
          this.currentMap.setCenter(this.getCoords(this.initCoords));

          this.$nextTick(() => {
            this.initClickEvents(map);
            this.initMapEvents(map);

            if (this.filters.length) {
              this.applyMarkerFilters(this.filters);
            }

            this.isInit = true;
            if (this.KEY < 2) {
              this.KEY += 1;
            }
          });
        } catch (error) {
          console.log(error);
          this.isInit = true;
        }
      }
    },
    onDrag() {
      this.balloonOpened = false;
    },
    onDragEnd(e) {
      const objectManager = this.currentMap.geoObjects.get(0);
      const currentMarker = objectManager
        && objectManager.objects.getById(this.activeMarkerId);

      if (currentMarker) {
        this.$nextTick(() => {
          const prevZoom = e.get('oldZoom');
          const newZoom = e.get('newZoom');
          const currentBounds = this.currentMap.getBounds();
          const pixelsBound1 = this.currentMap.panes.get('controls')
            .toClientPixels(this.toGlobalPixels(currentBounds[0], newZoom));
          const pixelsBound2 = this.currentMap.panes.get('controls')
            .toClientPixels(this.toGlobalPixels(currentBounds[1], newZoom));

          // координаты границы карты
          const pixels = {
            x1: pixelsBound1[0],
            y1: pixelsBound1[1],
            x2: pixelsBound2[0],
            y2: pixelsBound2[1],
          };

          let newX;
          let newY;

          // при изменении зума пересчитывать позицию с новым зумом
          if (prevZoom !== newZoom) {
            const pagePixels = this.getMarkerPixelPosition(this.activeMarkerId, newZoom);

            newX = pagePixels[0];
            newY = pagePixels[1];

            this.balloonPositionMap = pagePixels;
          } else {
            const offset = this.balloonPositionMap;
            const prevCenter = e.get('newGlobalPixelCenter');
            const nextCenter = e.get('oldGlobalPixelCenter');
            const deltaX = nextCenter[0] - prevCenter[0];
            const deltaY = nextCenter[1] - prevCenter[1];

            newX = offset[0] + deltaX;
            newY = offset[1] + deltaY;

            this.balloonPositionMap = [newX, newY];
          }

          this.balloonOpened = true;

          // смена позиции балуна, когда он вылезает за пределы карты
          if (
            (newX < pixels.x1 || newY > pixels.y1)
              || (newX > pixels.x2 || newY < pixels.y2)
              || newZoom < 8
          ) {
            this.balloonOpened = false;
            this.balloonDirection = 'default';
          } else if (newX + 205 > pixels.x2 && newY - 235 < pixels.y2) {
            this.balloonDirection = 'left top';

            if (newX + 35 > pixels.x2) {
              this.balloonOpened = false;
            }
          } else if (newX - (240 / 2) < pixels.x1) {
            this.balloonOpened = false;
          } else if (newX + (240 / 2) > pixels.x2) {
            this.balloonDirection = 'left';
            if (newX + 50 > pixels.x2) {
              this.balloonOpened = false;
            }
          } else if (newY - 235 < pixels.y2) {
            this.balloonDirection = 'top';
          } else {
            this.balloonDirection = 'default';
          }
        });
      }
    },
    onClick(e) {
      // if (this.activeMarkerId) {
      // this.setMarkerAppearance(this.activeMarkerId);
      // }

      const target = e.get('objectId');
      const activeEntityIndex = this.placemarks.findIndex(placemark => this.generateKey(placemark) === target);
      if (this.canShowMobile) {
        const center = this.toGlobalPixels(this.getCoords(this.placemarks[activeEntityIndex]), 16);
        const mobileOffset = window.screen.availHeight / 4;

        this.currentMap.setCenter(this.toCoords([center[0], center[1] - mobileOffset], 16), 16);
      } else {
        this.currentMap.setCenter(this.getCoords(this.placemarks[activeEntityIndex]), 16);
      }
      this.$nextTick(() => {
        const pagePixels = this.getMarkerPixelPosition(target);
        this.balloonOpened = true;
        this.balloonPositionMap = pagePixels;
      });

      if (!isNil(this.bus)) {
        this.bus.$emit('select-entity', [activeEntityIndex, target]);
        this.activeMarkerId = target;
      } else {
        this.activeMarkerId = target;
      }

      // this.setMarkerAppearance(target, true);
    },
    closeBalloon() {
      // this.setMarkerAppearance(markerId);
      this.balloonOpened = false;
      this.activeMarkerId = null;
    },
    compileTemplate(component, propsData) {
      const Extended = Vue.extend(component);
      let Instance = new Extended({
        route: this.$route,
        store: this.$store,
        propsData,
      });
      Instance.$mount();
      const html = Instance.$el && Instance.$el.outerHTML;
      Instance = null;
      return html;
    },
    getRenderedComponent(component, entity, props) {
      if (!isEmpty(component) || !isNil(component)) {
        return this.compileTemplate(component, { entity, ...props });
      }
      return '';
    },
    renderHintComponent(entity) {
      // TODO: Обязательно обратить внимание на память при большом количестве объектов на карте
      return this.getRenderedComponent(
        this.hintConfiguration.template,
        createHintEntity(this.hintConfiguration.type, entity)
      );
    },
    getCoords(entity) {
      // TODO: Workaround!!! Нужен гибкий адаптер сущностей для placemarks
      const coords = [];
      if (entity) {
        entity.coord_lat && coords.push(entity.coord_lat);
        entity.coord_lng && coords.push(entity.coord_lng);
        entity.lat && coords.push(entity.lat);
        entity.lng && coords.push(entity.lng);
      } else {
        coords.push(0);
        coords.push(0);
      }
      return coords;
    },
    getMarkerStyle(type) {
      if (!type || (type !== 'originals' && type !== 'analogs')) {
        return this.$options.YandexMapMarkerTypeB;
      }

      return type === 'originals' ? this.$options.YandexMapMarkerTypeA : this.$options.YandexMapMarkerTypeB;
    },
    toGlobalPixels(coords, zoom = this.currentMap.getZoom()) {
      const projection = this.currentMap.options.get('projection');
      return projection.toGlobalPixels(coords, zoom);
    },
    toCoords(pixels, zoom = this.currentMap.getZoom()) {
      const projection = this.currentMap.options.get('projection');
      return projection.fromGlobalPixels(pixels, zoom);
    },
    getMarkerPixelPosition(markerId, zoom = this.currentMap.getZoom()) {
      const objectManager = this.currentMap.geoObjects.get(0);
      const currentMarker = objectManager.objects.getById(markerId);
      const gPixels = this.toGlobalPixels(currentMarker.geometry.coordinates, zoom);

      return this.currentMap.panes.get('controls').toClientPixels(gPixels);
    },
    setMarkerAppearance(markerId, active) {
      const objectManager = this.currentMap.geoObjects.get(0);
      if (active) {
        objectManager.objects.setObjectOptions(markerId, {
          iconImage: mapMarkerSvgAnalogs,
          zIndex: 215,
        });
      } else {
        objectManager.objects.setObjectOptions(markerId, this.$options.YandexMapMarkerTypeA);
      }
    },
    generateKey: generateMapMarkerKey,
    initClickEvents(map) {
      try {
        const objectManager = map.geoObjects.get(0);
        objectManager.objects.events.add('click', this.onClick);
      } catch (e) {
        // console.log(e);
      }
    },
    initMapEvents(map) {
      map.events.add('actiontick', this.onDrag);
      map.events.add('boundschange', this.onDragEnd);
    },
    onChangeActiveEntityIndex(activeIndex = this.activeEntityIndex) {
      this.currentMap.setCenter(
        this.getCoords(
          this.placemarks[activeIndex]
        ),
        16
      );
      // const objectManager = this.currentMap.geoObjects.get(0);
      const newId = this.generateKey(this.placemarks[activeIndex]);

      if (this.placemarks[activeIndex]) {
        // if (this.activeMarkerId) {
        //   this.setMarkerAppearance(this.activeMarkerId);
        // }

        this.activeMarkerId = newId;
        // const currentItem = objectManager.objects.getById(newId);
        // this.setMarkerAppearance(currentItem.id, true);
      }
    },
    applyMarkerFilters(filters) {
      const objectManager = this.currentMap.geoObjects.get(0);
      if (objectManager) {
        const isOriginals = filters.find(item => item === 'originals');
        const isAnalogs = filters.find(item => item === 'analogs');

        objectManager.setFilter((object) => {
          if (isOriginals && isAnalogs) {
            return true;
          }

          if (isOriginals) {
            return object.properties.type === 'originals';
          }

          if (isAnalogs) {
            return object.properties.type === 'analogs';
          }

          return false;
        });
      }
    },
  },
};
</script>

<style lang="postcss">
  @import '~/assets/css/components/map/hint.css';
  @import '~/assets/css/components/map/balloon.css';
  .appAbstractMap {
    position: relative;

    & .mapLoader {
      position: absolute;
      z-index: 99;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background-color: var(--bg-lightest);
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;
      & .action {
        display: inline-block;
        width: 4rem;
        height: 4rem;
        &:after {
          content: " ";
          display: block;
          width: 2.875rem;
          height: 2.875rem;
          border-radius: 50%;
          border: 5px solid #12445b;
          border-color: #12445b transparent #12445b transparent;
          animation: lds-dual-ring 1.2s linear infinite;
        }
      }
      @keyframes lds-dual-ring {
        0% {
          transform: rotate(0deg);
        }
        100% {
          transform: rotate(360deg);
        }
      }
    }

    & .mapPlaceholder {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background-color: var(--bg-lightest);
      text-align: center;
      display: none;
      flex-direction: column;
      justify-content: center;
      align-items: center;
    }

    &.-inited {
      & .mapLoader {
        display: none;
      }
    }

    &.-empty {
      & .mapPlaceholder {
        display: flex;
      }
    }
  }
  .appAbstractMap,
  .ymap-container {
    width: inherit;
    height: 40rem;
  }

  .ymaps-2-1-74-balloon__content {
    padding: 0 !important;
  }

  .ymaps-2-1-74-balloon__close + .ymaps-2-1-74-balloon__content {
    margin-right: 0!important;
  }

  .ymaps-2-1-74-balloon__tail::after {
    background-color: var(--bg-lightest) !important;
  }

  @media screen and (max-width: 980px) {
    .appAbstractMap {
      height: inherit;
    }

    .ymap-container {
      height: inherit;
    }

    .ymaps-2-1-74-balloon,
    .ymaps-2-1-74-hint-overlay {
      display: none;
    }
  }
</style>
